#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_ActivitySummerLuckDrawCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_ActivitySummerLuckDrawCFG> M_ActivitySummerLuckDrawCFG::msSingleton(nullptr);

int M_ActivitySummerLuckDrawCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivitySummerLuckDrawCFGData* M_ActivitySummerLuckDrawCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_ActivitySummerLuckDrawCFGData>& M_ActivitySummerLuckDrawCFG::GetMapData()
{
	return mMapData;
}

void M_ActivitySummerLuckDrawCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_ActivitySummerLuckDrawCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivitySummerLuckDrawCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mRaffleConsumption1 = element->IntAttribute("RaffleConsumption1");
		data.mRaffleConsumption2 = element->IntAttribute("RaffleConsumption2");
		data.mTriggerBottom = element->IntAttribute("TriggerBottom");
		data.mBottomGuard1 = element->IntAttribute("BottomGuard1");
		data.mBottomGuard2 = element->IntAttribute("BottomGuard2");
		data.mBottomGuard3 = element->IntAttribute("BottomGuard3");
		data.mConsumeID = element->IntAttribute("ConsumeID");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_ActivitySummerLuckDrawCFG::Load()
{
	Load("../Config/M_ActivitySummerLuckDrawCFG.xml");
}

M_ActivitySummerLuckDrawCFG* M_ActivitySummerLuckDrawCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivitySummerLuckDrawCFG());
	}
	return msSingleton.get();
}
